<template>
  <PageCard
    class="signIn_wrapper"
    gradient
    :title="$t('authorization.step3.part4.title')"
    pointColor="#fea911"
    :bordering="false">
    <div class="signIn_inner">
      <div
        class="signIn_inner-collapse">
        <ul
          class="signIn_inner-description ul">
          <li
            v-for="(item, key) in $t('authorization.step3.part4.description')"
            :key="key">{{item}}
          </li>
        </ul>
        <div class="signIn_inner-body flex flex-center">
          <div class="signIn_inner-padding">
            <BtnDark
              borderColor="#fea911"
              @click="clicked=true"
              :color="clicked ? '#fea911' : '#8591a9'"><label
              for="file">
              {{$t('authorization.step3.part4.title')}}</label>
              <template slot="img">
                <IconUpload
                  class="mt-3p ml-10"
                  :fill="clicked ? '#fea911' : '#8591a9'"></IconUpload>
              </template>
            </BtnDark>
            <input
              id="file"
              type="file"
              @change="onFileUpload"
              style="display: none;">
          </div>
        </div>
      </div>
    </div>
  </PageCard>
</template>

<script>
  import BtnDark from '~/components/UI/BtnSign_dark';
  import {Wallet} from '~/services/wallet/';
  import IconUpload from '~/components/UI/icons/icon-upload';
  import PageCard from '~/components/UI/PageCard';
  import notification
    from '~/components/UI/Notification/main.js';

  export default {
    name: "Step3_ThePart4",
    props: {
      active: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        clicked: false
      }
    },
    components: {
      BtnDark,
      IconUpload,
      PageCard
    },
    computed: {},
    methods: {
      onFileUpload(e) {
        if (e.target.files && e.target.files.length) {
          const file = e.target.files[0];
          const reader = new FileReader();
          reader.onload = () => {
            const keys = reader.result;
            this.checkKeys(keys);
            e.target && (e.target.value = null);
          };
          reader.readAsText(file);
        }
      },
      checkKeys(keys) {
        try {
          let privateKeys = keys.split(':');
          privateKeys[0] = privateKeys[0].replace(/\(Active\)/gi, '');
          if (privateKeys.length > 1) {
            privateKeys[1] = privateKeys[1].replace(/\(Owner\)/gi, '');
          }
          if (!Wallet.isValidPrivate(privateKeys)) {
            notification.info({
              message: 'Private key is not a valid',
            });
            return;
          }
          const publicKeys = Wallet.privateToPublic(privateKeys);
          this.$emit('finish', {
            privateKeys,
            publicKeys
          });
        } catch (e) {
          console.log('error check keys- ', e);
          throw e;
        }
      }
    }
  }
</script>
